﻿;OPTIMIZATIONS START
#NoEnv
#HotkeyInterval 1000
#KeyHistory 0
ListLines Off

; Process, Priority, , AboveNormal
SetBatchLines, -1

SetKeyDelay, -1, -1
SetMouseDelay, -1
SetDefaultMouseSpeed, 0
SetWinDelay, -1

SendMode Input
;OPTIMIZATIONS END

#SingleInstance force
#MaxHotkeysPerInterval 1000

; SetKeyDelay, 0, 0

; SetBatchLines -1  ; Ensures maximum effectiveness of this method.

SleepDuration := 10  ; This can sometimes be finely adjusted (e.g. 2 is different than 3) depending on the value below.
TimePeriod := 3 ; Try 7 or 3.  See comment below.
; On a PC whose sleep duration normally rounds up to 15.6 ms, try TimePeriod:=7 to allow
; somewhat shorter sleeps, and try TimePeriod:=3 or less to allow the shortest possible sleeps.
DllCall("Winmm\timeBeginPeriod", "UInt", TimePeriod)  ; Affects all applications, not just this script's DllCall("Sleep"...), but does not affect SetTimer.
Iterations := 50
StartTime := A_TickCount

Loop %Iterations%
    DllCall("Sleep", "UInt", SleepDuration)  ; Must use DllCall instead of the Sleep command.

DllCall("Winmm\timeEndPeriod", "UInt", TimePeriod)  ; Should be called to restore system to normal.
; Uncomment line below to check sleep duration (is somewhat hardware dependant)
;MsgBox % "Sleep duration = " . (A_TickCount - StartTime) / Iterations

DllCall("Winmm\timeBeginPeriod", "UInt", TimePeriod) ; call this now since end is called again at the end of the script, saves us from having to call begin and end on every macro keypress

OnExit("OnScriptExit")

OnScriptExit(ExitReason, ExitCode)
{
	DllCall("Winmm\timeEndPeriod", UInt, TimePeriod)
}

MouseShown()
{
	StructSize := A_PtrSize + 16
	VarSetCapacity(InfoStruct, StructSize)
	NumPut(StructSize, InfoStruct)
	DllCall("GetCursorInfo", UInt, &InfoStruct)
	Result := NumGet(InfoStruct, 8)

	if Result > 1
		return 1
	else
		return 0
}

; #If (WinActive("ahk_exe Control_DX11.exe") or WinActive("ahk_exe Control_DX12.exe") or WinActive("ahk_exe Game_rmdutggamepass_f.exe")) and !MouseShown()
GameWindowActive()
{
	if WinActive("ahk_exe Control_DX11.exe") or WinActive("ahk_exe Control_DX12.exe") or WinActive("ahk_exe Game_rmdutggamepass_f.exe")
		return 1
	else
		return 0
}

#If GameWindowActive() and !MouseShown()
	Wheelup::
	Wheeldown::
	+Wheelup::
	+Wheeldown::
		; DllCall("Winmm\timeBeginPeriod", "UInt", TimePeriod)
		Send {Space down}
		; Sleep 10
		DllCall("Sleep", "UInt", SleepDuration)
		Send {Space up}
		; DllCall("Winmm\timeEndPeriod", "UInt", TimePeriod)
		return
	~*Z::
		; DllCall("Winmm\timeBeginPeriod", "UInt", TimePeriod)
		; 20 & 10 for fast delay
		Send {Space down}
		DllCall("Sleep", "UInt", 15)
		while (GetKeyState("Z")) {
			Send {Space up}
			DllCall("Sleep", "UInt", 45)
			Send {Space down}
			DllCall("Sleep", "UInt", 15)
		}
		Send {Space up}
		; DllCall("Winmm\timeEndPeriod", "UInt", TimePeriod)
		return


; ExitApp:
; MsgBox % "Sleep duration = " . (A_TickCount - StartTime) / Iterations
; DllCall("Winmm\timeEndPeriod", UInt, TimePeriod)


